#define				PWMMODEOFF				0
#define				PWMMODE1					1
#define				PWMMODE2					2
#define				PWMMODE3					3
#define				PWMMODE4					4
#define				PWMMODE5					5
#define				PWMMODE6					6
#define				PWMMODE7					7
#define				PWMMODE8					8
#define				PWMMODE9					9
#define				PWMMODE10				10

#define				PWMMODENUMS				11

// MODENUMBER | CHANNEL | 0=Value 1=Speed 2=Change Mode
volatile uint8_t pwmmode[PWMMODENUMS][32][3];
int runmode;
int ismode;
int modedatachange;

void modes_init(void);
void set_pwmmode_value(uint8_t modenr, uint8_t channel, uint8_t value);
uint8_t get_pwmmode_value(uint8_t modenr, uint8_t channel);

void set_pwmmode_speed(uint8_t modenr, uint8_t channel, uint8_t value);
uint8_t get_pwmmode_speed(uint8_t modenr, uint8_t channel);

void set_pwmmode_changemode(uint8_t modenr, uint8_t channel, uint8_t value);
uint8_t get_pwmmode_changemode(uint8_t modenr, uint8_t channel);

#define				PMW_DEF_MODE1_CH1			100
#define				PMW_DEF_MODE1_CH2			100
#define				PMW_DEF_MODE1_CH3			100
#define				PMW_DEF_MODE1_CH4			100
#define				PMW_DEF_MODE1_CH5			100
#define				PMW_DEF_MODE1_CH6			100
#define				PMW_DEF_MODE1_CH7			100
#define				PMW_DEF_MODE1_CH8			100
#define				PMW_DEF_MODE1_CH9			100
#define				PMW_DEF_MODE1_CH10		100
#define				PMW_DEF_MODE1_CH11		100
#define				PMW_DEF_MODE1_CH12		100
#define				PMW_DEF_MODE1_CH13		100
#define				PMW_DEF_MODE1_CH14		100
#define				PMW_DEF_MODE1_CH15		100
#define				PMW_DEF_MODE1_CH16		100
#define				PMW_DEF_MODE1_CH17		100
#define				PMW_DEF_MODE1_CH18		100
#define				PMW_DEF_MODE1_CH19		100
#define				PMW_DEF_MODE1_CH20		100
#define				PMW_DEF_MODE1_CH21		100
#define				PMW_DEF_MODE1_CH22		100
#define				PMW_DEF_MODE1_CH23		100
#define				PMW_DEF_MODE1_CH24		100
#define				PMW_DEF_MODE1_CH25		100
#define				PMW_DEF_MODE1_CH26		100
#define				PMW_DEF_MODE1_CH27		100
#define				PMW_DEF_MODE1_CH28		100
#define				PMW_DEF_MODE1_CH29		100
#define				PMW_DEF_MODE1_CH30		100
#define				PMW_DEF_MODE1_CH31		100
#define				PMW_DEF_MODE1_CH32		100
#define				PMW_DEF_MODE2_CH1			0
#define				PMW_DEF_MODE2_CH2			0
#define				PMW_DEF_MODE2_CH3			0
#define				PMW_DEF_MODE2_CH4			0
#define				PMW_DEF_MODE2_CH5			0
#define				PMW_DEF_MODE2_CH6			0
#define				PMW_DEF_MODE2_CH7			0
#define				PMW_DEF_MODE2_CH8			0
#define				PMW_DEF_MODE2_CH9			0
#define				PMW_DEF_MODE2_CH10		0
#define				PMW_DEF_MODE2_CH11		0
#define				PMW_DEF_MODE2_CH12		0
#define				PMW_DEF_MODE2_CH13		0
#define				PMW_DEF_MODE2_CH14		0
#define				PMW_DEF_MODE2_CH15		0
#define				PMW_DEF_MODE2_CH16		0
#define				PMW_DEF_MODE2_CH17		0
#define				PMW_DEF_MODE2_CH18		0
#define				PMW_DEF_MODE2_CH19		0
#define				PMW_DEF_MODE2_CH20		0
#define				PMW_DEF_MODE2_CH21		0
#define				PMW_DEF_MODE2_CH22		0
#define				PMW_DEF_MODE2_CH23		0
#define				PMW_DEF_MODE2_CH24		0
#define				PMW_DEF_MODE2_CH25		0
#define				PMW_DEF_MODE2_CH26		0
#define				PMW_DEF_MODE2_CH27		0
#define				PMW_DEF_MODE2_CH28		0
#define				PMW_DEF_MODE2_CH29		0
#define				PMW_DEF_MODE2_CH30		0
#define				PMW_DEF_MODE2_CH31		0
#define				PMW_DEF_MODE2_CH32		0
#define				PMW_DEF_MODE3_CH1			0
#define				PMW_DEF_MODE3_CH2			0
#define				PMW_DEF_MODE3_CH3			0
#define				PMW_DEF_MODE3_CH4			0
#define				PMW_DEF_MODE3_CH5			0
#define				PMW_DEF_MODE3_CH6			0
#define				PMW_DEF_MODE3_CH7			0
#define				PMW_DEF_MODE3_CH8			0
#define				PMW_DEF_MODE3_CH9			0
#define				PMW_DEF_MODE3_CH10		0
#define				PMW_DEF_MODE3_CH11		0
#define				PMW_DEF_MODE3_CH12		0
#define				PMW_DEF_MODE3_CH13		0
#define				PMW_DEF_MODE3_CH14		0
#define				PMW_DEF_MODE3_CH15		0
#define				PMW_DEF_MODE3_CH16		0
#define				PMW_DEF_MODE3_CH17		0
#define				PMW_DEF_MODE3_CH18		0
#define				PMW_DEF_MODE3_CH19		0
#define				PMW_DEF_MODE3_CH20		0
#define				PMW_DEF_MODE3_CH21		0
#define				PMW_DEF_MODE3_CH22		0
#define				PMW_DEF_MODE3_CH23		0
#define				PMW_DEF_MODE3_CH24		0
#define				PMW_DEF_MODE3_CH25		0
#define				PMW_DEF_MODE3_CH26		0
#define				PMW_DEF_MODE3_CH27		0
#define				PMW_DEF_MODE3_CH28		0
#define				PMW_DEF_MODE3_CH29		0
#define				PMW_DEF_MODE3_CH30		0
#define				PMW_DEF_MODE3_CH31		0
#define				PMW_DEF_MODE3_CH32		0
#define				PMW_DEF_MODE4_CH1			0
#define				PMW_DEF_MODE4_CH2			0
#define				PMW_DEF_MODE4_CH3			0
#define				PMW_DEF_MODE4_CH4			0
#define				PMW_DEF_MODE4_CH5			0
#define				PMW_DEF_MODE4_CH6			0
#define				PMW_DEF_MODE4_CH7			0
#define				PMW_DEF_MODE4_CH8			0
#define				PMW_DEF_MODE4_CH9			0
#define				PMW_DEF_MODE4_CH10		0
#define				PMW_DEF_MODE4_CH11		0
#define				PMW_DEF_MODE4_CH12		0
#define				PMW_DEF_MODE4_CH13		0
#define				PMW_DEF_MODE4_CH14		0
#define				PMW_DEF_MODE4_CH15		0
#define				PMW_DEF_MODE4_CH16		0
#define				PMW_DEF_MODE4_CH17		0
#define				PMW_DEF_MODE4_CH18		0
#define				PMW_DEF_MODE4_CH19		0
#define				PMW_DEF_MODE4_CH20		0
#define				PMW_DEF_MODE4_CH21		0
#define				PMW_DEF_MODE4_CH22		0
#define				PMW_DEF_MODE4_CH23		0
#define				PMW_DEF_MODE4_CH24		0
#define				PMW_DEF_MODE4_CH25		0
#define				PMW_DEF_MODE4_CH26		0
#define				PMW_DEF_MODE4_CH27		0
#define				PMW_DEF_MODE4_CH28		0
#define				PMW_DEF_MODE4_CH29		0
#define				PMW_DEF_MODE4_CH30		0
#define				PMW_DEF_MODE4_CH31		0
#define				PMW_DEF_MODE4_CH32		0
#define				PMW_DEF_MODE5_CH1			0
#define				PMW_DEF_MODE5_CH2			0
#define				PMW_DEF_MODE5_CH3			0
#define				PMW_DEF_MODE5_CH4			0
#define				PMW_DEF_MODE5_CH5			0
#define				PMW_DEF_MODE5_CH6			0
#define				PMW_DEF_MODE5_CH7			0
#define				PMW_DEF_MODE5_CH8			0
#define				PMW_DEF_MODE5_CH9			0
#define				PMW_DEF_MODE5_CH10		0
#define				PMW_DEF_MODE5_CH11		0
#define				PMW_DEF_MODE5_CH12		0
#define				PMW_DEF_MODE5_CH13		0
#define				PMW_DEF_MODE5_CH14		0
#define				PMW_DEF_MODE5_CH15		0
#define				PMW_DEF_MODE5_CH16		0
#define				PMW_DEF_MODE5_CH17		0
#define				PMW_DEF_MODE5_CH18		0
#define				PMW_DEF_MODE5_CH19		0
#define				PMW_DEF_MODE5_CH20		0
#define				PMW_DEF_MODE5_CH21		0
#define				PMW_DEF_MODE5_CH22		0
#define				PMW_DEF_MODE5_CH23		0
#define				PMW_DEF_MODE5_CH24		0
#define				PMW_DEF_MODE5_CH25		0
#define				PMW_DEF_MODE5_CH26		0
#define				PMW_DEF_MODE5_CH27		0
#define				PMW_DEF_MODE5_CH28		0
#define				PMW_DEF_MODE5_CH29		0
#define				PMW_DEF_MODE5_CH30		0
#define				PMW_DEF_MODE5_CH31		0
#define				PMW_DEF_MODE5_CH32		0
#define				PMW_DEF_MODE6_CH1			0
#define				PMW_DEF_MODE6_CH2			0
#define				PMW_DEF_MODE6_CH3			0
#define				PMW_DEF_MODE6_CH4			0
#define				PMW_DEF_MODE6_CH5			0
#define				PMW_DEF_MODE6_CH6			0
#define				PMW_DEF_MODE6_CH7			0
#define				PMW_DEF_MODE6_CH8			0
#define				PMW_DEF_MODE6_CH9			0
#define				PMW_DEF_MODE6_CH10		0
#define				PMW_DEF_MODE6_CH11		0
#define				PMW_DEF_MODE6_CH12		0
#define				PMW_DEF_MODE6_CH13		0
#define				PMW_DEF_MODE6_CH14		0
#define				PMW_DEF_MODE6_CH15		0
#define				PMW_DEF_MODE6_CH16		0
#define				PMW_DEF_MODE6_CH17		0
#define				PMW_DEF_MODE6_CH18		0
#define				PMW_DEF_MODE6_CH19		0
#define				PMW_DEF_MODE6_CH20		0
#define				PMW_DEF_MODE6_CH21		0
#define				PMW_DEF_MODE6_CH22		0
#define				PMW_DEF_MODE6_CH23		0
#define				PMW_DEF_MODE6_CH24		0
#define				PMW_DEF_MODE6_CH25		0
#define				PMW_DEF_MODE6_CH26		0
#define				PMW_DEF_MODE6_CH27		0
#define				PMW_DEF_MODE6_CH28		0
#define				PMW_DEF_MODE6_CH29		0
#define				PMW_DEF_MODE6_CH30		0
#define				PMW_DEF_MODE6_CH31		0
#define				PMW_DEF_MODE6_CH32		0
#define				PMW_DEF_MODE7_CH1			0
#define				PMW_DEF_MODE7_CH2			0
#define				PMW_DEF_MODE7_CH3			0
#define				PMW_DEF_MODE7_CH4			0
#define				PMW_DEF_MODE7_CH5			0
#define				PMW_DEF_MODE7_CH6			0
#define				PMW_DEF_MODE7_CH7			0
#define				PMW_DEF_MODE7_CH8			0
#define				PMW_DEF_MODE7_CH9			0
#define				PMW_DEF_MODE7_CH10		0
#define				PMW_DEF_MODE7_CH11		0
#define				PMW_DEF_MODE7_CH12		0
#define				PMW_DEF_MODE7_CH13		0
#define				PMW_DEF_MODE7_CH14		0
#define				PMW_DEF_MODE7_CH15		0
#define				PMW_DEF_MODE7_CH16		0
#define				PMW_DEF_MODE7_CH17		0
#define				PMW_DEF_MODE7_CH18		0
#define				PMW_DEF_MODE7_CH19		0
#define				PMW_DEF_MODE7_CH20		0
#define				PMW_DEF_MODE7_CH21		0
#define				PMW_DEF_MODE7_CH22		0
#define				PMW_DEF_MODE7_CH23		0
#define				PMW_DEF_MODE7_CH24		0
#define				PMW_DEF_MODE7_CH25		0
#define				PMW_DEF_MODE7_CH26		0
#define				PMW_DEF_MODE7_CH27		0
#define				PMW_DEF_MODE7_CH28		0
#define				PMW_DEF_MODE7_CH29		0
#define				PMW_DEF_MODE7_CH30		0
#define				PMW_DEF_MODE7_CH31		0
#define				PMW_DEF_MODE7_CH32		0
#define				PMW_DEF_MODE8_CH1			0
#define				PMW_DEF_MODE8_CH2			0
#define				PMW_DEF_MODE8_CH3			0
#define				PMW_DEF_MODE8_CH4			0
#define				PMW_DEF_MODE8_CH5			0
#define				PMW_DEF_MODE8_CH6			0
#define				PMW_DEF_MODE8_CH7			0
#define				PMW_DEF_MODE8_CH8			0
#define				PMW_DEF_MODE8_CH9			0
#define				PMW_DEF_MODE8_CH10		0
#define				PMW_DEF_MODE8_CH11		0
#define				PMW_DEF_MODE8_CH12		0
#define				PMW_DEF_MODE8_CH13		0
#define				PMW_DEF_MODE8_CH14		0
#define				PMW_DEF_MODE8_CH15		0
#define				PMW_DEF_MODE8_CH16		0
#define				PMW_DEF_MODE8_CH17		0
#define				PMW_DEF_MODE8_CH18		0
#define				PMW_DEF_MODE8_CH19		0
#define				PMW_DEF_MODE8_CH20		0
#define				PMW_DEF_MODE8_CH21		0
#define				PMW_DEF_MODE8_CH22		0
#define				PMW_DEF_MODE8_CH23		0
#define				PMW_DEF_MODE8_CH24		0
#define				PMW_DEF_MODE8_CH25		0
#define				PMW_DEF_MODE8_CH26		0
#define				PMW_DEF_MODE8_CH27		0
#define				PMW_DEF_MODE8_CH28		0
#define				PMW_DEF_MODE8_CH29		0
#define				PMW_DEF_MODE8_CH30		0
#define				PMW_DEF_MODE8_CH31		0
#define				PMW_DEF_MODE8_CH32		0
#define				PMW_DEF_MODE9_CH1			0
#define				PMW_DEF_MODE9_CH2			0
#define				PMW_DEF_MODE9_CH3			0
#define				PMW_DEF_MODE9_CH4			0
#define				PMW_DEF_MODE9_CH5			0
#define				PMW_DEF_MODE9_CH6			0
#define				PMW_DEF_MODE9_CH7			0
#define				PMW_DEF_MODE9_CH8			0
#define				PMW_DEF_MODE9_CH9			0
#define				PMW_DEF_MODE9_CH10		0
#define				PMW_DEF_MODE9_CH11		0
#define				PMW_DEF_MODE9_CH12		0
#define				PMW_DEF_MODE9_CH13		0
#define				PMW_DEF_MODE9_CH14		0
#define				PMW_DEF_MODE9_CH15		0
#define				PMW_DEF_MODE9_CH16		0
#define				PMW_DEF_MODE9_CH17		0
#define				PMW_DEF_MODE9_CH18		0
#define				PMW_DEF_MODE9_CH19		0
#define				PMW_DEF_MODE9_CH20		0
#define				PMW_DEF_MODE9_CH21		0
#define				PMW_DEF_MODE9_CH22		0
#define				PMW_DEF_MODE9_CH23		0
#define				PMW_DEF_MODE9_CH24		0
#define				PMW_DEF_MODE9_CH25		0
#define				PMW_DEF_MODE9_CH26		0
#define				PMW_DEF_MODE9_CH27		0
#define				PMW_DEF_MODE9_CH28		0
#define				PMW_DEF_MODE9_CH29		0
#define				PMW_DEF_MODE9_CH30		0
#define				PMW_DEF_MODE9_CH31		0
#define				PMW_DEF_MODE9_CH32		0
#define				PMW_DEF_MODE10_CH1		0
#define				PMW_DEF_MODE10_CH2		0
#define				PMW_DEF_MODE10_CH3		0
#define				PMW_DEF_MODE10_CH4		0
#define				PMW_DEF_MODE10_CH5		0
#define				PMW_DEF_MODE10_CH6		0
#define				PMW_DEF_MODE10_CH7		0
#define				PMW_DEF_MODE10_CH8		0
#define				PMW_DEF_MODE10_CH9		0
#define				PMW_DEF_MODE10_CH10		0
#define				PMW_DEF_MODE10_CH11		0
#define				PMW_DEF_MODE10_CH12		0
#define				PMW_DEF_MODE10_CH13		0
#define				PMW_DEF_MODE10_CH14		0
#define				PMW_DEF_MODE10_CH15		0
#define				PMW_DEF_MODE10_CH16		0
#define				PMW_DEF_MODE10_CH17		0
#define				PMW_DEF_MODE10_CH18		0
#define				PMW_DEF_MODE10_CH19		0
#define				PMW_DEF_MODE10_CH20		0
#define				PMW_DEF_MODE10_CH21		0
#define				PMW_DEF_MODE10_CH22		0
#define				PMW_DEF_MODE10_CH23		0
#define				PMW_DEF_MODE10_CH24		0
#define				PMW_DEF_MODE10_CH25		0
#define				PMW_DEF_MODE10_CH26		0
#define				PMW_DEF_MODE10_CH27		0
#define				PMW_DEF_MODE10_CH28		0
#define				PMW_DEF_MODE10_CH29		0
#define				PMW_DEF_MODE10_CH30		0
#define				PMW_DEF_MODE10_CH31		0
#define				PMW_DEF_MODE10_CH32		0
